### Praat Stimmprofil
# Joerg Mayer, jmayer@lingphon.net
# This is free software under the terms of the GNU General Public License 3

endeditor

### check for valid Praat version 
# in versions 6044 - 6046 CPP calculation was corrupted
# versions before 5363 are too old (old syntax)
pversion = praatVersion
if pversion >= 6044 and pversion <= 6046
	exitScript: "Ihre Praat-Version (" + string$ (pversion) + ") ist nicht geeignet." + newline$ + "In den Versionen 6.0.44 bis 6.0.46 wird der CPPS falsch berechnet." + newline$ + "Bitte installieren Sie eine aktuelle Praat-Version (6.0.47 oder neuer)." + newline$
elsif pversion < 5363
	exitScript: "Ihre Praat-Version ist zu alt." + newline$ + "Bitte installieren Sie eine aktuelle Version." + newline$
endif

settingsFile$ = defaultDirectory$ + "/stimmprofil.settings"
settingsFile$ = replace$ (settingsFile$, "//", "/", 0)
recordingSpec$ = defaultDirectory$ + "/recording"
recordingSpec$ = replace$ (recordingSpec$, "//", "/", 0)
tempFile$ = defaultDirectory$ + "/stimmprofil"
tempFile$ = replace$ (tempFile$, "//", "/", 0)
avqiSpec$ = defaultDirectory$ + "/avqi"
avqiSpec$ = replace$ (avqiSpec$, "//", "/", 0)

# delete tmp files
nocheck deleteFile: tempFile$ + "0"
nocheck deleteFile: tempFile$ + "1"
nocheck deleteFile: tempFile$ + "2"
nocheck deleteFile: tempFile$ + "3"
nocheck deleteFile: tempFile$ + "4"
nocheck deleteFile: tempFile$ + "5"
nocheck deleteFile: tempFile$ + "6"
nocheck deleteFile: recordingSpec$
nocheck deleteFile: avqiSpec$
thisTempFile$ = tempFile$ + "0"

# default settings or saved settings
untersucher$ = ""
mikrophon$ = ""
aD_Wandler$ = ""
aD_Parameter$ = ""
computer$ = ""
if windows
	betriebssystem$ = "Windows"
elsif macintosh
	betriebssystem$ = "Mac OS X"
elsif unix
	betriebssystem$ = "Linux"
endif
if fileReadable (settingsFile$)
	settings$ = readFile$ (settingsFile$)
	if index (settings$, "untersucher") > 0
		untersucher$ = extractLine$ (settings$, "untersucher: ")
	endif
	if index (settings$, "mikrophon") > 0
		mikrophon$ =  extractLine$ (settings$, "mikrophon: ")
	endif
	if index (settings$, "aD_Wandler") > 0
		aD_Wandler$ =  extractLine$ (settings$, "aD_Wandler: ")
	endif
	if index (settings$, "aD_Parameter") > 0
		aD_Parameter$ =  extractLine$ (settings$, "aD_Parameter: ")
	endif
	if index (settings$, "computer") > 0
		computer$ =	 extractLine$ (settings$, "computer: ")
	endif
	if index (settings$, "betriebssystem") > 0
		betriebssystem$ =	 extractLine$ (settings$, "betriebssystem: ")
	endif
endif

date$ = date$ ()
day$ = mid$ (date$, 9, 2)
year$ = mid$ (date$, 21, 4)
month$ = mid$ (date$, 5, 3)
if month$ = "Jan"
	month$ = "1"
elsif month$ = "Feb"
	month$ = "2"
elsif month$ = "Mar"
	month$ = "3"
elsif month$ = "Apr"
	month$ = "4"
elsif month$ = "May"
	month$ = "5"
elsif month$ = "Jun"
	month$ = "6"
elsif month$ = "Jul"
	month$ = "7"
elsif month$ = "Aug"
	month$ = "8"
elsif month$ = "Sep"
	month$ = "9"
elsif month$ = "Oct"
	month$ = "10"
elsif month$ = "Nov"
	month$ = "11"
elsif month$ = "Dec"
	month$ = "12"
endif
datum$ = day$ + "." + month$ + "." + year$
aufnahmedatum$ = datum$

beginPause: "Allgemeine Angaben"
	comment: "Stimmprofil"
	sentence: "Untersucher", untersucher$
	sentence: "Datum", datum$
	comment: "Patient"
	sentence: "Name", ""
	sentence: "Geburtsdatum", ""
	choice: "Geschlecht", 0
		option: "w"
		option: "m"
	sentence: "Befund", ""
	comment: "Aufnahmetechnik"
	sentence: "Mikrophon", mikrophon$
	sentence: "AD Wandler", aD_Wandler$
	sentence: "AD Parameter", aD_Parameter$
	sentence: "Computer", computer$
	sentence: "Betriebssystem", betriebssystem$
	comment: ""
	comment: "Sie können nun nacheinander bis zu 6 Stimmproben für dieses"
	comment: "Stimmprofil auswählen. Öffnen Sie eine Aufnahme, wählen Sie"
	comment: "einen Abschnitt aus und klicken Sie:"
	comment: "Pulses > Stimmprofil: Stimmprobe hinzufügen"
clicked = endPause: "Abbrechen", "OK", 2, 1
if clicked = 1
	# nocheck deleteFile: tempFile$
	nocheck deleteFile: recordingSpec$
	exitScript ()
endif

# save settings
nocheck writeFileLine: settingsFile$, "untersucher: ", untersucher$
nocheck appendFileLine: settingsFile$, "mikrophon: ", mikrophon$
nocheck appendFileLine: settingsFile$, "aD_Wandler: ", aD_Wandler$
nocheck appendFileLine: settingsFile$, "aD_Parameter: ", aD_Parameter$
nocheck appendFileLine: settingsFile$, "computer: ", computer$
nocheck appendFileLine: settingsFile$, "betriebssystem: ", betriebssystem$

# save general data
writeFileLine: thisTempFile$, "untersucher: ", untersucher$
appendFileLine: thisTempFile$, "datum: ", datum$
appendFileLine: thisTempFile$, "mikrophon: ", mikrophon$
appendFileLine: thisTempFile$, "aD_Wandler: ", aD_Wandler$
appendFileLine: thisTempFile$, "aD_Parameter: ", aD_Parameter$
appendFileLine: thisTempFile$, "computer: ", computer$
appendFileLine: thisTempFile$, "betriebssystem: ", betriebssystem$
appendFileLine: thisTempFile$, "name: ", name$
appendFileLine: thisTempFile$, "geburtsdatum: ", geburtsdatum$
appendFileLine: thisTempFile$, "geschlecht: ", geschlecht
appendFileLine: thisTempFile$, "befund: ", befund$

# start drawing
include stimmprofil_draw.praat


